Xerces-J API: Class MixedContentModel

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.validators.common
Class MixedContentModel

    java.lang.Object
      |
      +--org.apache.xerces.validators.common.MixedContentModel

public class MixedContentModel
extends java.lang.Object
implements XMLContentModel

MixedContentModel is a derivative of the abstract content model base class that handles the special case of mixed model elements. If an element is mixed model, it has PCDATA as its first possible content, followed by an alternation of the possible children. The children cannot have any numeration or order, so it must look like this:

       <!ELEMENT Foo ((#PCDATA|a|b|c|)*)>

So, all we have to do is to keep an array of the possible children and validate by just looking up each child being validated by looking it up in the list.

Version:
  $Id: MixedContentModel.java,v 1.14 2001/07/16 21:22:16 sandygao Exp $

Constructor Summary
`MixedContentModel(QName[] childList, int[] childListType, int offset, int length)` Constructs a mixed content model.
`MixedContentModel(QName[] childList, int[] childListType, int offset, int length, boolean ordered)` Constructs a mixed content model.
`MixedContentModel(QName[] childList, int[] childListType, int offset, int length, boolean ordered, boolean dtd)` Constructs a mixed content model.

Method Summary
`void` | `checkUniqueParticleAttribution(SchemaGrammar gram)`
`ContentLeafNameTypeVector` | `getContentLeafNameTypeVector()`
`void` | `setSubstitutionGroupComparator(SubstitutionGroupComparator comparator)` The setter method to pass in the SubstitutionGroupComparator.
`int` | `validateContent(QName[] children, int offset, int length)` Check that the specified content is valid according to this content model.
`int` | `validateContentSpecial(QName[] children, int offset, int length)` This method is different from "validateContent" in that it will try to use the SubstitutionGroupComparator to match children against the content model.
`int` | `whatCanGoHere(boolean fullyValid, InsertableElementsInfo info)` Returns information about which elements can be placed at a particular point in the passed element's content model.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MixedContentModel

    public MixedContentModel(QName[] childList,
                             int[] childListType,
                             int offset,
                             int length)
                      throws CMException

  Constructs a mixed content model.
  Parameters:
    `count` - The child count.
    `childList` - The list of allowed children.
  Throws:
    CMException - Thrown if content model can't be built.

### MixedContentModel

    public MixedContentModel(QName[] childList,
                             int[] childListType,
                             int offset,
                             int length,
                             boolean ordered)
                      throws CMException

  Constructs a mixed content model.
  Parameters:
    `count` - The child count.
    `childList` - The list of allowed children.
    `ordered` - True if content must be ordered.
  Throws:
    CMException - Thrown if content model can't be built.

### MixedContentModel

    public MixedContentModel(QName[] childList,
                             int[] childListType,
                             int offset,
                             int length,
                             boolean ordered,
                             boolean dtd)
                      throws CMException

  Constructs a mixed content model.
  Parameters:
    `count` - The child count.
    `childList` - The list of allowed children.
    `ordered` - True if content must be ordered.
  Throws:
    CMException - Thrown if content model can't be built.

Method Detail

### checkUniqueParticleAttribution

    public void checkUniqueParticleAttribution(SchemaGrammar gram)

  Specified by:
    checkUniqueParticleAttribution in interface XMLContentModel

### validateContent

    public int validateContent(QName[] children,
                               int offset,
                               int length)
                        throws java.lang.Exception

  Check that the specified content is valid according to this content model. This method can also be called to do 'what if' testing of content models just to see if they would be valid.

  A value of -1 in the children array indicates a PCDATA node. All other indexes will be positive and represent child elements. The count can be zero, since some elements have the EMPTY content model and that must be confirmed.

  Specified by:
    validateContent in interface XMLContentModel
  Parameters:
    `children` - The children of this element. Each integer is an index within the `StringPool` of the child element name. An index of -1 is used to indicate an occurrence of non-whitespace character data.
    `offset` - Offset into the array where the children starts.
    `length` - The number of entries in the `children` array.
  Returns:
    The value -1 if fully valid, else the 0 based index of the child that first failed. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.
  Throws:
    java.lang.Exception - Thrown on error.

### validateContentSpecial

    public int validateContentSpecial(QName[] children,
                                      int offset,
                                      int length)
                               throws java.lang.Exception

  Description copied from interface: XMLContentModel
  This method is different from "validateContent" in that it will try to use the SubstitutionGroupComparator to match children against the content model.

  A value of -1 in the children array indicates a PCDATA node. All other indexes will be positive and represent child elements. The count can be zero, since some elements have the EMPTY content model and that must be confirmed.

  Specified by:
    validateContentSpecial in interface XMLContentModel
  Tags copied from interface: XMLContentModel
  Parameters:
    `children` - The children of this element. Each integer is an index within the `StringPool` of the child element name. An index of -1 is used to indicate an occurrence of non-whitespace character data.
    `offset` - Offset into the array where the children starts.
    `length` - The number of entries in the `children` array.
  Returns:
    The value -1 if fully valid, else the 0 based index of the child that first failed. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.
  Throws:
    java.lang.Exception - Thrown on error.

### setSubstitutionGroupComparator

    public void setSubstitutionGroupComparator(SubstitutionGroupComparator comparator)

  Description copied from interface: XMLContentModel
  The setter method to pass in the SubstitutionGroupComparator.
  Specified by:
    setSubstitutionGroupComparator in interface XMLContentModel
  Tags copied from interface: XMLContentModel
  Parameters:
    `comparator` - a SubstitutionGroupComparator object.
  Returns:
  Throws:
    -

### whatCanGoHere

    public int whatCanGoHere(boolean fullyValid,
                             InsertableElementsInfo info)
                      throws java.lang.Exception

  Returns information about which elements can be placed at a particular point in the passed element's content model.

  Note that the incoming content model to test must be valid at least up to the insertion point. If not, then -1 will be returned and the info object will not have been filled in.

  If, on return, the info.isValidEOC flag is set, then the 'insert after' element is a valid end of content. In other words, nothing needs to be inserted after it to make the parent element's content model valid.

  Specified by:
    whatCanGoHere in interface XMLContentModel
  Parameters:
    `fullyValid` - Only return elements that can be inserted and still maintain the validity of subsequent elements past the insertion point (if any). If the insertion point is at the end, and this is true, then only elements that can be legal final states will be returned.
    `info` - An object that contains the required input data for the method, and which will contain the output information if successful.
  Returns:
    The value -1 if fully valid, else the 0 based index of the child that first failed before the insertion point. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.
  See Also:
    `InsertableElementsInfo`

### getContentLeafNameTypeVector

    public ContentLeafNameTypeVector getContentLeafNameTypeVector()

  Specified by:
    getContentLeafNameTypeVector in interface XMLContentModel

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2001 Apache XML Project. All Rights Reserved.